<rtflowfile version="1.0">
   <block name="Bullet" folder="User\" width="64" height="96">
      <resize constrainprop="false" allow="true"/>
      <instancename show="true" position="up"/>
      <blockname show="false" position="down"/>
      <portnames show="true" inside="false"/>
      <graphic class="rect" x1="0" y1="0" x2="64" y2="96">
         <fill fill="true" color="0x00BBFFFF"/>
      </graphic>
      <port name="x" type="real" x="0" y="16" kind="input" dir="left"/>
      <port name="y" type="real" x="0" y="32" kind="input" dir="left"/>
      <port name="rot" type="real" x="0" y="48" kind="input" dir="left"/>
      <port name="fire" type="bool" x="0" y="64" kind="input" dir="left"/>
      <port name="unfire" type="bool" x="0" y="80" kind="input" dir="left"/>
      <port name="bullet" type="bool" x="64" y="16" kind="output" dir="right"/>
      <port name="bulletx" type="real" x="64" y="32" kind="output" dir="right"/>
      <port name="bullety" type="real" x="64" y="48" kind="output" dir="right"/>
   </block>
   <schematic name="Bullet" width="903" height="602">
      <editor gridsize="16" alignports="true" autovalue="false"/>
      <binstance name="x" block="RealInput" x="64" y="56"/>
      <binstance name="y" block="RealInput" x="64" y="120"/>
      <binstance name="rot" block="RealInput" x="64" y="328"/>
      <binstance name="fire" block="BoolInput" x="64" y="248"/>
      <binstance name="unfire" block="BoolInput" x="64" y="264"/>
      <binstance name="SetReset1" block="SetReset" x="128" y="240"/>
      <binstance name="PositiveEdge1" block="PositiveEdge" x="208" y="192"/>
      <binstance name="D1" block="D" x="304" y="48"/>
      <binstance name="D2" block="D" x="304" y="112"/>
      <binstance name="bullet" block="BoolOutput" x="656" y="248"/>
      <binstance name="Cos1" block="Cos" x="128" y="320"/>
      <binstance name="Sin1" block="Sin" x="128" y="384"/>
      <binstance name="D3" block="D" x="304" y="320"/>
      <binstance name="D4" block="D" x="304" y="384"/>
      <binstance name="SpeedX" block="Gain" x="400" y="320">
         <instancename show="true" position="up"/>
         <blockname show="false" position="down"/>
         <portnames show="false" inside="false"/>
         <constant name="gain" value="150" show="true" x="11" y="16"/>
      </binstance>
      <binstance name="SpeedY" block="Gain" x="400" y="384">
         <instancename show="true" position="up"/>
         <blockname show="false" position="down"/>
         <portnames show="false" inside="false"/>
         <constant name="gain" value="150" show="true" x="11" y="16"/>
      </binstance>
      <binstance name="Add1" block="Add" x="592" y="320"/>
      <binstance name="Add2" block="Add" x="592" y="384"/>
      <binstance name="bulletx" block="RealOutput" x="672" y="328"/>
      <binstance name="bullety" block="RealOutput" x="672" y="392"/>
      <binstance name="Negation1" block="Negation" x="208" y="384"/>
      <binstance name="Integral1" block="IntegralWithReset" x="480" y="320"/>
      <binstance name="Integral2" block="IntegralWithReset" x="480" y="384"/>
      <connection name="fire" port1="fire.o" port2="SetReset1.set">
         <point x="80" y="256"/>
         <point x="128" y="256"/>
      </connection>
      <connection name="unfire" port1="unfire.o" port2="SetReset1.reset">
         <point x="80" y="272"/>
         <point x="128" y="272"/>
      </connection>
      <connection name="bullet" port1="SetReset1.o" port2="PositiveEdge1.i">
         <point x="176" y="256"/>
         <point x="192" y="256"/>
         <point x="192" y="208"/>
         <point x="208" y="208"/>
      </connection>
      <connection name="x" port1="x.o" port2="D1.value">
         <point x="80" y="64"/>
         <point x="304" y="64"/>
      </connection>
      <connection name="y" port1="y.o" port2="D2.value">
         <point x="80" y="128"/>
         <point x="304" y="128"/>
      </connection>
      <connection name="true_fire" port1="PositiveEdge1.o" port2="D1.set">
         <point x="240" y="208"/>
         <point x="272" y="208"/>
         <point x="272" y="80"/>
         <point x="304" y="80"/>
      </connection>
      <connection name="true_fire" port1="PositiveEdge1.o" port2="D2.set">
         <point x="240" y="208"/>
         <point x="272" y="208"/>
         <point x="272" y="144"/>
         <point x="304" y="144"/>
      </connection>
      <connection name="bullet" port1="SetReset1.o" port2="bullet.i0">
         <point x="176" y="256"/>
         <point x="656" y="256"/>
      </connection>
      <connection name="rot" port1="rot.o" port2="Cos1.i0">
         <point x="80" y="336"/>
         <point x="128" y="336"/>
      </connection>
      <connection name="rot" port1="rot.o" port2="Sin1.i0">
         <point x="80" y="336"/>
         <point x="104" y="336"/>
         <point x="104" y="400"/>
         <point x="128" y="400"/>
      </connection>
      <connection name="cos" port1="Cos1.o" port2="D3.value">
         <point x="160" y="336"/>
         <point x="304" y="336"/>
      </connection>
      <connection name="true_fire" port1="PositiveEdge1.o" port2="D3.set">
         <point x="240" y="208"/>
         <point x="272" y="208"/>
         <point x="272" y="352"/>
         <point x="304" y="352"/>
      </connection>
      <connection name="true_fire" port1="PositiveEdge1.o" port2="D4.set">
         <point x="240" y="208"/>
         <point x="272" y="208"/>
         <point x="272" y="416"/>
         <point x="304" y="416"/>
      </connection>
      <connection name="dir_x" port1="D3.o" port2="SpeedX.i0">
         <point x="352" y="336"/>
         <point x="400" y="336"/>
      </connection>
      <connection name="dir_y" port1="D4.o" port2="SpeedY.i0">
         <point x="352" y="400"/>
         <point x="400" y="400"/>
      </connection>
      <connection name="origin_y" port1="D2.o" port2="Add2.i0">
         <point x="352" y="128"/>
         <point x="560" y="128"/>
         <point x="560" y="392"/>
         <point x="594" y="392"/>
      </connection>
      <connection name="origin_x" port1="D1.o" port2="Add1.i0">
         <point x="352" y="64"/>
         <point x="576" y="64"/>
         <point x="576" y="328"/>
         <point x="594" y="328"/>
      </connection>
      <connection name="bulletx" port1="Add1.o" port2="bulletx.i0">
         <point x="624" y="336"/>
         <point x="672" y="336"/>
      </connection>
      <connection name="bullety" port1="Add2.o" port2="bullety.i0">
         <point x="624" y="400"/>
         <point x="672" y="400"/>
      </connection>
      <connection name="sin" port1="Sin1.o" port2="Negation1.i">
         <point x="160" y="400"/>
         <point x="208" y="400"/>
      </connection>
      <connection name="negsin" port1="Negation1.o" port2="D4.value">
         <point x="240" y="400"/>
         <point x="304" y="400"/>
      </connection>
      <connection name="speed_x" port1="SpeedX.o" port2="Integral1.i">
         <point x="432" y="336"/>
         <point x="480" y="336"/>
      </connection>
      <connection name="relx" port1="Integral1.o" port2="Add1.i1">
         <point x="528" y="336"/>
         <point x="544" y="336"/>
         <point x="544" y="344"/>
         <point x="594" y="344"/>
      </connection>
      <connection name="speed_y" port1="SpeedY.o" port2="Integral2.i">
         <point x="432" y="400"/>
         <point x="480" y="400"/>
      </connection>
      <connection name="rely" port1="Integral2.o" port2="Add2.i1">
         <point x="528" y="400"/>
         <point x="544" y="400"/>
         <point x="544" y="408"/>
         <point x="594" y="408"/>
      </connection>
      <connection name="true_fire" port1="PositiveEdge1.o" port2="Integral1.rst">
         <point x="240" y="208"/>
         <point x="464" y="208"/>
         <point x="464" y="352"/>
         <point x="480" y="352"/>
      </connection>
      <connection name="true_fire" port1="PositiveEdge1.o" port2="Integral2.rst">
         <point x="240" y="208"/>
         <point x="464" y="208"/>
         <point x="464" y="416"/>
         <point x="480" y="416"/>
      </connection>
   </schematic>
</rtflowfile>
